
# Internals

require_relative './aspose-email-cloud/api_client'
require_relative './aspose-email-cloud/api_invoker'
require_relative './aspose-email-cloud/api_error'
require_relative './aspose-email-cloud/version'
require_relative './aspose-email-cloud/configuration'

# API classes

require_relative './aspose-email-cloud/api/ai_bcr_api'
require_relative './aspose-email-cloud/api/ai_name_api'
require_relative './aspose-email-cloud/api/calendar_api'
require_relative './aspose-email-cloud/api/client_account_api'
require_relative './aspose-email-cloud/api/client_folder_api'
require_relative './aspose-email-cloud/api/client_message_api'
require_relative './aspose-email-cloud/api/client_thread_api'
require_relative './aspose-email-cloud/api/contact_api'
require_relative './aspose-email-cloud/api/disposable_email_api'
require_relative './aspose-email-cloud/api/email_api'
require_relative './aspose-email-cloud/api/email_config_api'
require_relative './aspose-email-cloud/api/file_api'
require_relative './aspose-email-cloud/api/folder_api'
require_relative './aspose-email-cloud/api/mapi_calendar_api'
require_relative './aspose-email-cloud/api/mapi_contact_api'
require_relative './aspose-email-cloud/api/mapi_message_api'
require_relative './aspose-email-cloud/api/storage_api'

# Request models

require_relative './aspose-email-cloud/models/ai_bcr_parse_request'
require_relative './aspose-email-cloud/models/ai_name_complete_request'
require_relative './aspose-email-cloud/models/ai_name_expand_request'
require_relative './aspose-email-cloud/models/ai_name_format_request'
require_relative './aspose-email-cloud/models/ai_name_genderize_request'
require_relative './aspose-email-cloud/models/ai_name_match_request'
require_relative './aspose-email-cloud/models/ai_name_parse_request'
require_relative './aspose-email-cloud/models/ai_name_parse_email_address_request'
require_relative './aspose-email-cloud/models/calendar_convert_request'
require_relative './aspose-email-cloud/models/calendar_from_file_request'
require_relative './aspose-email-cloud/models/calendar_get_request'
require_relative './aspose-email-cloud/models/calendar_get_as_alternate_request'
require_relative './aspose-email-cloud/models/calendar_get_as_file_request'
require_relative './aspose-email-cloud/models/calendar_get_list_request'
require_relative './aspose-email-cloud/models/client_account_get_request'
require_relative './aspose-email-cloud/models/client_account_get_multi_request'
require_relative './aspose-email-cloud/models/client_folder_get_list_request'
require_relative './aspose-email-cloud/models/client_message_append_file_request'
require_relative './aspose-email-cloud/models/client_message_fetch_request'
require_relative './aspose-email-cloud/models/client_message_fetch_file_request'
require_relative './aspose-email-cloud/models/client_message_list_request'
require_relative './aspose-email-cloud/models/client_message_send_file_request'
require_relative './aspose-email-cloud/models/client_thread_get_list_request'
require_relative './aspose-email-cloud/models/client_thread_get_messages_request'
require_relative './aspose-email-cloud/models/contact_convert_request'
require_relative './aspose-email-cloud/models/contact_from_file_request'
require_relative './aspose-email-cloud/models/contact_get_request'
require_relative './aspose-email-cloud/models/contact_get_as_file_request'
require_relative './aspose-email-cloud/models/contact_get_list_request'
require_relative './aspose-email-cloud/models/disposable_email_is_disposable_request'
require_relative './aspose-email-cloud/models/email_convert_request'
require_relative './aspose-email-cloud/models/email_from_file_request'
require_relative './aspose-email-cloud/models/email_get_request'
require_relative './aspose-email-cloud/models/email_get_as_file_request'
require_relative './aspose-email-cloud/models/email_get_list_request'
require_relative './aspose-email-cloud/models/email_config_discover_request'
require_relative './aspose-email-cloud/models/copy_file_request'
require_relative './aspose-email-cloud/models/delete_file_request'
require_relative './aspose-email-cloud/models/download_file_request'
require_relative './aspose-email-cloud/models/move_file_request'
require_relative './aspose-email-cloud/models/upload_file_request'
require_relative './aspose-email-cloud/models/copy_folder_request'
require_relative './aspose-email-cloud/models/create_folder_request'
require_relative './aspose-email-cloud/models/delete_folder_request'
require_relative './aspose-email-cloud/models/get_files_list_request'
require_relative './aspose-email-cloud/models/move_folder_request'
require_relative './aspose-email-cloud/models/mapi_calendar_from_file_request'
require_relative './aspose-email-cloud/models/mapi_calendar_get_request'
require_relative './aspose-email-cloud/models/mapi_contact_from_file_request'
require_relative './aspose-email-cloud/models/mapi_contact_get_request'
require_relative './aspose-email-cloud/models/mapi_message_from_file_request'
require_relative './aspose-email-cloud/models/mapi_message_get_request'
require_relative './aspose-email-cloud/models/get_disc_usage_request'
require_relative './aspose-email-cloud/models/get_file_versions_request'
require_relative './aspose-email-cloud/models/object_exists_request'
require_relative './aspose-email-cloud/models/storage_exists_request'

# Models

require_relative './aspose-email-cloud/models/ai_bcr_image'
require_relative './aspose-email-cloud/models/ai_bcr_options'
require_relative './aspose-email-cloud/models/ai_bcr_parse_storage_request'
require_relative './aspose-email-cloud/models/ai_name_component'
require_relative './aspose-email-cloud/models/ai_name_cultural_context'
require_relative './aspose-email-cloud/models/ai_name_extracted'
require_relative './aspose-email-cloud/models/ai_name_extracted_component'
require_relative './aspose-email-cloud/models/ai_name_formatted'
require_relative './aspose-email-cloud/models/ai_name_gender_hypothesis'
require_relative './aspose-email-cloud/models/ai_name_match_result'
require_relative './aspose-email-cloud/models/ai_name_mismatch'
require_relative './aspose-email-cloud/models/ai_name_parsed_request'
require_relative './aspose-email-cloud/models/ai_name_weighted'
require_relative './aspose-email-cloud/models/ai_name_weighted_variants'
require_relative './aspose-email-cloud/models/associated_person'
require_relative './aspose-email-cloud/models/attachment_base'
require_relative './aspose-email-cloud/models/calendar_as_alternate_request'
require_relative './aspose-email-cloud/models/calendar_as_file_request'
require_relative './aspose-email-cloud/models/calendar_dto'
require_relative './aspose-email-cloud/models/calendar_reminder'
require_relative './aspose-email-cloud/models/client_account_base_request'
require_relative './aspose-email-cloud/models/contact_as_file_request'
require_relative './aspose-email-cloud/models/contact_dto'
require_relative './aspose-email-cloud/models/contact_photo'
require_relative './aspose-email-cloud/models/content_type'
require_relative './aspose-email-cloud/models/content_type_parameter'
require_relative './aspose-email-cloud/models/customer_event'
require_relative './aspose-email-cloud/models/disc_usage'
require_relative './aspose-email-cloud/models/discover_email_config_request'
require_relative './aspose-email-cloud/models/email_account_config'
require_relative './aspose-email-cloud/models/email_address'
require_relative './aspose-email-cloud/models/email_as_file_request'
require_relative './aspose-email-cloud/models/email_client_account'
require_relative './aspose-email-cloud/models/email_client_account_credentials'
require_relative './aspose-email-cloud/models/email_client_multi_account'
require_relative './aspose-email-cloud/models/email_dto'
require_relative './aspose-email-cloud/models/email_thread'
require_relative './aspose-email-cloud/models/enum_with_custom_of_associated_person_category'
require_relative './aspose-email-cloud/models/enum_with_custom_of_email_address_category'
require_relative './aspose-email-cloud/models/enum_with_custom_of_event_category'
require_relative './aspose-email-cloud/models/enum_with_custom_of_instant_messenger_category'
require_relative './aspose-email-cloud/models/enum_with_custom_of_phone_number_category'
require_relative './aspose-email-cloud/models/enum_with_custom_of_postal_address_category'
require_relative './aspose-email-cloud/models/enum_with_custom_of_url_category'
require_relative './aspose-email-cloud/models/error'
require_relative './aspose-email-cloud/models/error_details'
require_relative './aspose-email-cloud/models/file_versions'
require_relative './aspose-email-cloud/models/files_list'
require_relative './aspose-email-cloud/models/files_upload_result'
require_relative './aspose-email-cloud/models/instant_messenger_address'
require_relative './aspose-email-cloud/models/list_response_of_ai_name_component'
require_relative './aspose-email-cloud/models/list_response_of_ai_name_extracted'
require_relative './aspose-email-cloud/models/list_response_of_ai_name_gender_hypothesis'
require_relative './aspose-email-cloud/models/list_response_of_contact_dto'
require_relative './aspose-email-cloud/models/list_response_of_email_account_config'
require_relative './aspose-email-cloud/models/list_response_of_email_dto'
require_relative './aspose-email-cloud/models/list_response_of_email_thread'
require_relative './aspose-email-cloud/models/list_response_of_mail_message_base'
require_relative './aspose-email-cloud/models/list_response_of_mail_server_folder'
require_relative './aspose-email-cloud/models/list_response_of_storage_file_location'
require_relative './aspose-email-cloud/models/list_response_of_storage_model_of_calendar_dto'
require_relative './aspose-email-cloud/models/list_response_of_storage_model_of_contact_dto'
require_relative './aspose-email-cloud/models/list_response_of_storage_model_of_email_dto'
require_relative './aspose-email-cloud/models/mail_address'
require_relative './aspose-email-cloud/models/mail_message_base'
require_relative './aspose-email-cloud/models/mail_server_folder'
require_relative './aspose-email-cloud/models/mapi_attachment_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_as_file_request'
require_relative './aspose-email-cloud/models/mapi_calendar_attendees_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_event_recurrence_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_exception_info_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_recurrence_pattern_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_time_zone_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_time_zone_info_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_time_zone_rule_dto'
require_relative './aspose-email-cloud/models/mapi_contact_as_file_request'
require_relative './aspose-email-cloud/models/mapi_contact_electronic_address_dto'
require_relative './aspose-email-cloud/models/mapi_contact_electronic_address_property_set_dto'
require_relative './aspose-email-cloud/models/mapi_contact_event_property_set_dto'
require_relative './aspose-email-cloud/models/mapi_contact_name_property_set_dto'
require_relative './aspose-email-cloud/models/mapi_contact_other_property_set_dto'
require_relative './aspose-email-cloud/models/mapi_contact_personal_info_property_set_dto'
require_relative './aspose-email-cloud/models/mapi_contact_physical_address_dto'
require_relative './aspose-email-cloud/models/mapi_contact_physical_address_property_set_dto'
require_relative './aspose-email-cloud/models/mapi_contact_professional_property_set_dto'
require_relative './aspose-email-cloud/models/mapi_contact_telephone_property_set_dto'
require_relative './aspose-email-cloud/models/mapi_electronic_address_dto'
require_relative './aspose-email-cloud/models/mapi_message_as_file_request'
require_relative './aspose-email-cloud/models/mapi_message_item_base_dto'
require_relative './aspose-email-cloud/models/mapi_property_descriptor'
require_relative './aspose-email-cloud/models/mapi_property_dto'
require_relative './aspose-email-cloud/models/mapi_recipient_dto'
require_relative './aspose-email-cloud/models/name_value_pair'
require_relative './aspose-email-cloud/models/object_exist'
require_relative './aspose-email-cloud/models/phone_number'
require_relative './aspose-email-cloud/models/postal_address'
require_relative './aspose-email-cloud/models/recurrence_pattern_dto'
require_relative './aspose-email-cloud/models/reminder_attendee'
require_relative './aspose-email-cloud/models/reminder_trigger'
require_relative './aspose-email-cloud/models/storage_exist'
require_relative './aspose-email-cloud/models/storage_file'
require_relative './aspose-email-cloud/models/storage_folder_location'
require_relative './aspose-email-cloud/models/storage_model_of_calendar_dto'
require_relative './aspose-email-cloud/models/storage_model_of_contact_dto'
require_relative './aspose-email-cloud/models/storage_model_of_email_client_account'
require_relative './aspose-email-cloud/models/storage_model_of_email_client_multi_account'
require_relative './aspose-email-cloud/models/storage_model_of_email_dto'
require_relative './aspose-email-cloud/models/storage_model_of_mapi_calendar_dto'
require_relative './aspose-email-cloud/models/storage_model_of_mapi_contact_dto'
require_relative './aspose-email-cloud/models/storage_model_of_mapi_message_dto'
require_relative './aspose-email-cloud/models/url'
require_relative './aspose-email-cloud/models/value_t_of_boolean'
require_relative './aspose-email-cloud/models/value_t_of_string'
require_relative './aspose-email-cloud/models/ai_bcr_image_storage_file'
require_relative './aspose-email-cloud/models/ai_name_component_list'
require_relative './aspose-email-cloud/models/ai_name_extracted_list'
require_relative './aspose-email-cloud/models/ai_name_gender_hypothesis_list'
require_relative './aspose-email-cloud/models/ai_name_match_parsed_request'
require_relative './aspose-email-cloud/models/alternate_view'
require_relative './aspose-email-cloud/models/attachment'
require_relative './aspose-email-cloud/models/calendar_save_request'
require_relative './aspose-email-cloud/models/calendar_storage_list'
require_relative './aspose-email-cloud/models/client_account_save_multi_request'
require_relative './aspose-email-cloud/models/client_account_save_request'
require_relative './aspose-email-cloud/models/client_folder_create_request'
require_relative './aspose-email-cloud/models/client_folder_delete_request'
require_relative './aspose-email-cloud/models/client_message_append_request'
require_relative './aspose-email-cloud/models/client_message_base_request'
require_relative './aspose-email-cloud/models/client_message_send_request'
require_relative './aspose-email-cloud/models/client_thread_base_request'
require_relative './aspose-email-cloud/models/contact_list'
require_relative './aspose-email-cloud/models/contact_save_request'
require_relative './aspose-email-cloud/models/contact_storage_list'
require_relative './aspose-email-cloud/models/daily_recurrence_pattern_dto'
require_relative './aspose-email-cloud/models/email_account_config_list'
require_relative './aspose-email-cloud/models/email_client_account_oauth_credentials'
require_relative './aspose-email-cloud/models/email_client_account_password_credentials'
require_relative './aspose-email-cloud/models/email_config_discover_oauth_request'
require_relative './aspose-email-cloud/models/email_config_discover_password_request'
require_relative './aspose-email-cloud/models/email_list'
require_relative './aspose-email-cloud/models/email_save_request'
require_relative './aspose-email-cloud/models/email_storage_list'
require_relative './aspose-email-cloud/models/email_thread_list'
require_relative './aspose-email-cloud/models/file_version'
require_relative './aspose-email-cloud/models/linked_resource'
require_relative './aspose-email-cloud/models/mail_message_base64'
require_relative './aspose-email-cloud/models/mail_message_base_list'
require_relative './aspose-email-cloud/models/mail_message_dto'
require_relative './aspose-email-cloud/models/mail_message_mapi'
require_relative './aspose-email-cloud/models/mail_server_folder_list'
require_relative './aspose-email-cloud/models/mapi_binary_property_dto'
require_relative './aspose-email-cloud/models/mapi_boolean_property_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_daily_recurrence_pattern_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_save_request'
require_relative './aspose-email-cloud/models/mapi_calendar_weekly_recurrence_pattern_dto'
require_relative './aspose-email-cloud/models/mapi_calendar_yearly_and_monthly_recurrence_pattern_dto'
require_relative './aspose-email-cloud/models/mapi_contact_dto'
require_relative './aspose-email-cloud/models/mapi_contact_photo_dto'
require_relative './aspose-email-cloud/models/mapi_contact_save_request'
require_relative './aspose-email-cloud/models/mapi_date_time_property_dto'
require_relative './aspose-email-cloud/models/mapi_file_as_property_dto'
require_relative './aspose-email-cloud/models/mapi_importance_property_dto'
require_relative './aspose-email-cloud/models/mapi_int_property_dto'
require_relative './aspose-email-cloud/models/mapi_known_property_descriptor'
require_relative './aspose-email-cloud/models/mapi_legacy_free_busy_property_dto'
require_relative './aspose-email-cloud/models/mapi_message_dto'
require_relative './aspose-email-cloud/models/mapi_message_save_request'
require_relative './aspose-email-cloud/models/mapi_multi_int_property_dto'
require_relative './aspose-email-cloud/models/mapi_multi_string_property_dto'
require_relative './aspose-email-cloud/models/mapi_physical_address_index_property_dto'
require_relative './aspose-email-cloud/models/mapi_pid_property_descriptor'
require_relative './aspose-email-cloud/models/mapi_response_type_property_dto'
require_relative './aspose-email-cloud/models/mapi_string_property_dto'
require_relative './aspose-email-cloud/models/monthly_recurrence_pattern_dto'
require_relative './aspose-email-cloud/models/storage_file_location'
require_relative './aspose-email-cloud/models/storage_file_location_list'
require_relative './aspose-email-cloud/models/task_regenerating_pattern_dto'
require_relative './aspose-email-cloud/models/weekly_recurrence_pattern_dto'
require_relative './aspose-email-cloud/models/yearly_recurrence_pattern_dto'
require_relative './aspose-email-cloud/models/client_message_delete_request'
require_relative './aspose-email-cloud/models/client_message_move_request'
require_relative './aspose-email-cloud/models/client_message_set_is_read_request'
require_relative './aspose-email-cloud/models/client_thread_delete_request'
require_relative './aspose-email-cloud/models/client_thread_move_request'
require_relative './aspose-email-cloud/models/client_thread_set_is_read_request'
require_relative './aspose-email-cloud/models/mapi_pid_lid_property_descriptor'
require_relative './aspose-email-cloud/models/mapi_pid_name_property_descriptor'
require_relative './aspose-email-cloud/models/mapi_pid_tag_property_descriptor'

require_relative './aspose-email-cloud/api/email_cloud'


    
require_relative './aspose-email-cloud/api/mapi_group'
    
require_relative './aspose-email-cloud/api/client_group'
    
require_relative './aspose-email-cloud/api/ai_group'
    
require_relative './aspose-email-cloud/api/cloud_storage_group'
    

